/*============================================================================
|   Copyright (C) 2002  Jonathan Harm
| 
| 
|   This program is free software; you can redistribute it and/or 
|   modify it under the terms of the GNU General Public License 
|   as published by the Free Software Foundation; either version 2 
|   of the License, or (at your option) any later version. 
|   This program is distributed in the hope that it will be useful, 
|   but WITHOUT ANY WARRANTY; without even the implied warranty of 
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
|   GNU General Public License for more details. 
|   You should have received a copy of the GNU General Public License 
|   along with this program; if not, write to the Free Software 
|    
|   Foundation, Inc.,  
|   59 Temple Place - Suite 330 
|   Boston, MA  02111-1307, USA. 
| 
|   
| 
|                   chkres.c for SQL Query Generator
| 
|  This program is under the GPL see http://www.gnu.org for more info 
| 
|   
|                   http://change.to/opensource 
|                   110983@lycos.com 
| 
\============================================================================*/
#include "querygen.h"

//this function will check to see if *wordtocheck is a sql reserved word
//if it is the function will return 1, else 0 is returned

int chkres( char *wordtocheck )
{


       char reserved_word[326][15] = {   {"absolute"}, {"action"}, {"add"}, {"after"}, {"all"}, {"allocate"},
                                                         {"alter"}, {"and"}, {"any"}, {"are"}, {"as"}, {"asc"}, {"ascending"},
                                                         {"assertion"}, {"at"}, {"authorization"}, {"auto"}, {"autoinc"},
                                                         {"avg"}, {"backup"}, {"before"}, {"before"}, {"begin"}, {"between"},
                                                         {"bit"}, {"blob"}, {"boolean"}, {"both"}, {"break"}, {"browse"},
                                                         {"bulk"}, {"by"}, {"bytes"}, {"cache"}, {"cascade"}, {"case"}, {"cast"},
                                                         {"catalog"}, {"char"}, {"character"}, {"check"}, {"checkpoint"},
                                                         {"close"}, {"clustered"}, {"coalesce"}, {"collate"}, {"column"},
                                                         {"comment"}, {"commit"}, {"committed"}, {"compute"}, {"computed"},
                                                         {"conditional"}, {"confirm"}, {"connect"}, {"connection"},
                                                         {"constraint"}, {"constraints"}, {"containing"}, {"contains"},
                                                         {"containstable"},  {"continue"}, {"controlrow"}, {"convert"}, {"count"},
                                                         {"create"}, {"cross"}, {"cstring"}, {"cube"}, {"current"}, {"cursor"},
                                                         {"database"}, {"date"}, {"datetime"}, {"day"}, {"dbcc"}, {"deallocate"},
                                                         {"debug"}, {"dec"}, {"decimal"}, {"declare"}, {"default"}, {"delete"},
                                                         {"deny"}, {"desc"}, {"descending"}, {"describe"}, {"disconnect"}, {"disk"},
                                                         {"distinct"}, {"distributed"}, {"do"}, {"domain"}, {"double"}, {"drop"},
                                                         {"dummy"}, {"dump"}, {"else"}, {"end"}, {"errlvl"}, {"errorexit"}, {"escape"},
                                                         {"except"}, {"exception"}, {"exec"}, {"execute"}, {"exists"}, {"exit"},
                                                         {"external"}, {"extract"}, {"false"}, {"fetch"}, {"file"}, {"fillfactor"}, {"filter"},
                                                         {"float"}, {"floppy"}, {"for"}, {"foreign"}, {"found"}, {"freetext"},
                                                         {"freetexttable"}, {"from"}, {"full"}, {"function"}, {"generator"}, {"get"},
                                                         {"go"}, {"goto"}, {"grant"}, {"group"}, {"having"}, {"holdlock"}, {"hour"},
                                                         {"identity"}, {"if"}, {"in"}, {"inacive"}, {"index"}, {"indicator"}, {"inner"},
                                                         {"input"}, {"insert"}, {"int"}, {"integer"}, {"intersect"}, {"interval"}, {"into"},
                                                         {"is"}, {"isolation"}, {"join"}, {"key"}, {"kill"}, {"language"}, {"last"}, {"leading"},
                                                         {"left"}, {"length"}, {"level"}, {"like"}, {"lineno"}, {"load"}, {"local"}, {"logfile"},
                                                         {"long"}, {"lower"}, {"manual"}, {"match"}, {"max"}, {"merge"}, {"message"},
                                                         {"min"}, {"minute"}, {"mirrorexit"}, {"module"}, {"money"}, {"month"},
                                                         {"names"}, {"national"}, {"nchar"}, {"next"}, {"no"}, {"nocheck"},
                                                         {"nonclustered"}, {"none"}, {"not"}, {"null"}, {"nullif"}, {"numeric"}, {"of"},
                                                         {"off"}, {"offsets"}, {"on"}, {"once"}, {"only"}, {"open"}, {"option"}, {"or"},
                                                         {"order"}, {"outer"}, {"output"}, {"over"}, {"overflow"}, {"pad"}, {"page"},
                                                         {"pages"}, {"parameter"}, {"partial"}, {"password"}, {"percent"}, {"perm"},
                                                         {"permanent"}, {"pipe"}, {"plan"}, {"position"}, {"precision"}, {"prepare"},
                                                         {"primary"}, {"print"}, {"prior"}, {"privileges"}, {"proc"}, {"procedure"},
                                                         {"processexit"}, {"protected"}, {"public"}, {"raiserror"}, {"read"}, {"readtext"},
                                                         {"real"}, {"references"}, {"relative"}, {"replication"}, {"reserv"}, {"reserving"},
                                                         {"restore"}, {"restrict"}, {"retain"}, {"return"}, {"returns"}, {"revoke"}, {"right"},
                                                         {"rollback"}, {"rollup"}, {"rowcount"}, {"rule"}, {"save"}, {"schema"},
                                                         {"second"}, {"section"}, {"segment"}, {"select"}, {"sequence"}, {"set"},
                                                         {"setuser"}, {"shadow"}, {"shared"}, {"shutdown"}, {"singular"}, {"size"},
                                                         {"smallint"}, {"snapshot"}, {"some"}, {"sort"}, {"space"}, {"sql"}, {"sqlcode"},
                                                         {"sqlerror"}, {"stability"}, {"starting"}, {"stsrts"}, {"statistics"}, {"substring"},
                                                         {"sum"}, {"suspend"}, {"table"}, {"tape"}, {"temp"}, {"temporary"}, {"text"},
                                                         {"textsize"}, {"then"}, {"time"}, {"timestamp"}, {"to"}, {"top"}, {"trailing"},
                                                         {"tran"}, {"transaction"}, {"translate"}, {"trigger"}, {"trim"}, {"true"},
                                                         {"truncate"}, {"uncommitted"}, {"union"}, {"unique"}, {"update"},
                                                         {"updatetext"}, {"upper"}, {"usage"}, {"use"}, {"user"}, {"using"}, {"value"},
                                                         {"values"}, {"varchar"}, {"variable"}, {"varying"}, {"view"}, {"volume"},
                                                         {"wait"}, {"waitfor"}, {"when"}, {"where"}, {"while"}, {"with"}, {"work"},
                                                         {"write"}, {"writetext"}, {"year"}, {"zone"} };




        char wordtocheck_array[15]; //use array to change wordtocheck to lower case
        int i; //for counting in the loop


       //change to lower case
       strcpy(wordtocheck_array, wordtocheck);

       for(i = 0; i < 15; i++)
       {
           wordtocheck_array[i] = tolower(wordtocheck_array[i]);
       }



      for(i  = 0; i < 326; i++)
       {

            if( strcmp(reserved_word[i], wordtocheck_array) ==  0)
             return 1;

        }


        return 0;


}



